// Licensed to Elasticsearch B.V. under one or more contributor
// license agreements. See the NOTICE file distributed with
// this work for additional information regarding copyright
// ownership. Elasticsearch B.V. licenses this file to you under
// the Apache License, Version 2.0 (the "License"); you may
// not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.

// Code generated by the FlatBuffers compiler. DO NOT EDIT.

package schema

import "strconv"

type Type byte

const (
	TypeUnknown     Type = 0
	TypeFile        Type = 1
	TypeDir         Type = 2
	TypeSymlink     Type = 3
	TypeCharDevice  Type = 4
	TypeBlockDevice Type = 5
	TypeFIFO        Type = 6
	TypeSocket      Type = 7
)

var EnumNamesType = map[Type]string{
	TypeUnknown:     "Unknown",
	TypeFile:        "File",
	TypeDir:         "Dir",
	TypeSymlink:     "Symlink",
	TypeCharDevice:  "CharDevice",
	TypeBlockDevice: "BlockDevice",
	TypeFIFO:        "FIFO",
	TypeSocket:      "Socket",
}

var EnumValuesType = map[string]Type{
	"Unknown":     TypeUnknown,
	"File":        TypeFile,
	"Dir":         TypeDir,
	"Symlink":     TypeSymlink,
	"CharDevice":  TypeCharDevice,
	"BlockDevice": TypeBlockDevice,
	"FIFO":        TypeFIFO,
	"Socket":      TypeSocket,
}

func (v Type) String() string {
	if s, ok := EnumNamesType[v]; ok {
		return s
	}
	return "Type(" + strconv.FormatInt(int64(v), 10) + ")"
}
